#!/usr/bin/env node

const { info } = require('./lib/info')
const { getArgs } = require('./lib/getArgs')
const { naiftest } = require('./lib/naiftest')
const { naifshow } = require('./lib/naifshow')
const { naifnew } = require('./lib/naifnew')
const { naiftgbot } = require('./lib/naiftelegram')

// get command line args and commands
const { args, commands } = getArgs()

// debug
//console.log( args, commands ) 

switch ( commands[0] ) {

  case 'show':
  case 'desc':
  case 'describe':
    naifshow( args )
    break

  case 'test':
  case 'cli':
  case 'debug':
    naiftest( args )
    break

  case 'new':
  case 'generate':
     naifnew( args )
    break

  case 'telegram':
  case 'tgbot':
    naiftgbot( args )
    break

  case 'help':
  case 'info':
    console.log( info() )
    break

  default:
    console.log( info() )
    break

}  

