# `naif` command line interface tools

- [`naif`](#naif) 
- [`naif test`](#naif-test) 
- [`naif telegram`](#naif-telegram)
- [`naif new`](#naif-new) 
- [`naif show`](#naif-show) 

## `naif` 

```
$ naif
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

simple state-machines based dialog manager sdk for nodejs developers
version: 0.37.0, author: giorgio.robino@gmail.com

Documentation:
/usr/local/lib/node_modules/naifjs/README.md

Examples:
/usr/local/lib/node_modules/naifjs/examples

Usage:

  naif test
    command line dialog tester.

  naif telegram
    telegram bot dialog tester.

  naif new
    create dialog unit skeleton source code.

  naif show
    show dialog units and states of a directory.

  naif help
    show this help
``` 

## `naif show` 

command line dialog info

```
$ naif show
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

simple state-machines based dialog manager sdk for nodejs developers
version: 0.37.0, author: giorgio.robino@gmail.com

Dialog Units Description

Usage:
    naif show

    --dir=<directory path>
      Dialog units directory path. Mandatory argument.


Examples:

   naif show --dir=./examples/myApplication

```


## `naif test` 

It's the command line dialog tester/debugger

```
$ naif test
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

simple state-machines based dialog manager sdk for nodejs developers
version: 0.37.0, author: giorgio.robino@gmail.com

Command line dialog tester.

Usage:
    naif test

    --start=<unit.state>
      Initial dialog stateid in format "unit.state". Mandatory argument.

    --dir=<directory path>
      Dialog units directory path. Mandatory argument.


    --id=<id>
      User id. Optional argument.

    --logfile=<path/filename>
      Log filename with directory path. Optional argument.

    --sessionsfile=<path/filename>
      Sessions filename with directory path. Optional argument.


Examples:

   naif test --start=firstUnit.start --dir=./examples/myDialogs

   naif test --start=anotherUnit.showContents \
             --dir=./examples/app \
             --id=123456 \
             --logfile=/tmp/naifjs/dialogs.log \
             --sessionsfile=/tmp/naifjs/SESSIONS.json

```


| ![naif test usage](img/naiftest.png) |
|:--:|
| figure 1: `naif test --dir=examples/story_it --start=firstUnit.dogIntroduction`.  |



## `naif telegram` 

telegram bot to test a dialog, in a multiuser instant messaging environment.

```
$ naif telegram
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

simple state-machines based dialog manager sdk for nodejs developers
version: 0.37.0, author: giorgio.robino@gmail.com

Telegram bot dialog tester

Usage:
    naif telegram

    --token=<your telegram bot token id>
      Mandatory argument.


    --dir=<directory path>
      Dialog units directory path. Mandatory argument.


    --start=<unit.state>
      Initial dialog stateid in format "unit.state". Mandatory argument.


    --logfile=<path/filename>
      Log filename with directory path. Optional argument.


    --sessionsfile=<path/filename>
      Sessions filename with directory path. Optional argument.


Examples:

   naif telegram --token=YOUR_TELEGRAM_BOT_TOKEN \
                 --dir=./examples/yourApp \
                 --start=yourDialogUnit.startState \
                 --logfile=/tmp/naifjs/dialogs.log \
                 --logfile=/dev/stdout \
                 --sessionsfile=/tmp/naifjs/SESSIONS.json
```


| ![naif telegram usage](img/naiftelegram.png) |
|:--:|
| figure 2: using `naif telegram`. On backgrond the terminal. On the right the telegram bot running a dialog |


## `naif new` 

generate skeleton code for a new dialog.


```
$ naif new
 _   _       _  __     _
| \ | |     (_)/ _|   | |
|  \| | __ _ _| |_    | |___
| . ` |/ _` | |  _|   | / __|
| |\  | (_| | | || |__| \__ \
|_| \_|\__,_|_|_| \____/|___/

simple state-machines based dialog manager sdk for nodejs developers
version: 0.37.0, author: giorgio.robino@gmail.com

Create dialog skeleton source code.

Usage:

    naif new

    --unit=<unit name>
      Name of the dialog unit. Mandatory argument.

    --dir=<directory path>
      Dialog units directory path. Mandatory argument.

    --desc=<description>
      Unit name description (for dialog user). Optional argument.

    --outstates=<stateName1,stateName2,...>
      List of output state names, comma separated. Optional argument.

    --instates=<stateName1:numPatterns1,stateName2:numPattern2,...>
      List of input state names, comma separated.
      Each input state name is colon separated by a number of patterns. Mandatory argument.

     -e
      end case in pattern. Mandatory argument.

     -h
      help case in pattern. Mandatory argument.


Examples:

   naif new --tag=aUnit --dir=tmp/dialogs/aDialog --instates=oneState:4

   naif new --unit=indovinalaparola \
            --dir=./examples/indovinalaparola \
            --desc="Indovina La Parola" \
            --outstates=start \
            --instates=input1:2,input2:3

```

---

[top](#) | [home](../README.md)
